// Copyright © 2023 ab180. All rights reserved.

#include "AirbridgeSettings.h"

// Sets default values
UAirbridgeSettings::UAirbridgeSettings(const FObjectInitializer& ObjectInitializer)
	: Super(ObjectInitializer)
	, AppName("")
	, AppToken("")
	, LogLevel(EAirbridgeLogLevel::Warning)
	, IOSURIScheme("")
	, AndroidURIScheme("")
	, CustomDomain(/* Empty Array */)
	, SessionTimeoutSeconds(300)
	, UserInfoHashEnabled(true)
	, LocationCollectionEnabled(false)
	, TrackAirbridgeLinkOnly(false)
	, AutoStartTrackingEnabled(true)
	, FacebookDeferredAppLinkEnabled(false)
	, IOSTrackingAuthorizeTimeoutSeconds(30)
	, SdkSignatureSecretID("")
	, SdkSignatureSecret("")
	, TrackInSessionLifeCycleEventEnabled(false)
	, PauseEventTransmitOnBackgroundEnabled(false)
	, ResetEventBufferEnabled(false)
	, SdkEnabled(true)
	, AppMarketIdentifier("")
	, EventMaximumBufferCount(2147483647)
	, EventMaximumBufferSize(1024)
	, EventTransmitIntervalSeconds(0)
	, FacebookAppId("")
	, IsHandleAirbridgeDeeplinkOnly(false)
	, InAppPurchaseEnvironment(EAirbridgeInAppPurchaseEnvironment::Production)
	, CollectTCFDataEnabled(false)
{
}
