#pragma once
#include "Interfaces/AirbridgeCore.h"

class AirbridgeDefaultCore: public IAirbridgeCore
{
public:
	AirbridgeDefaultCore() = default;
	virtual ~AirbridgeDefaultCore() = default;

	virtual void EnableSDK() override;
	virtual void DisableSDK() override;
	virtual bool IsSDKEnabled() override;
	virtual void StartTracking() override;
	virtual void StopTracking() override;
	virtual bool IsTrackingEnabled() override;
	virtual void SetOnDeeplinkReceived(const AirbridgeStringParamFunction OnDeeplinkReceived) override;
	virtual void SetUserID(const FString& Id) override;
	virtual void ClearUserID() override;
	virtual void SetUserEmail(const FString& Email) override;
	virtual void ClearUserEmail() override;
	virtual void SetUserPhone(const FString& Phone) override;
	virtual void ClearUserPhone() override;
	virtual void SetUserAttribute(const FString& Key, const int32 Value) override;
	virtual void SetUserAttribute(const FString& Key, const int64 Value) override;
	virtual void SetUserAttribute(const FString& Key, const float Value) override;
	virtual void SetUserAttribute(const FString& Key, const double Value) override;
	virtual void SetUserAttribute(const FString& Key, const bool Value) override;
	virtual void SetUserAttribute(const FString& Key, const FString& Value) override;
	virtual void RemoveUserAttribute(const FString& Key) override;
	virtual void ClearUserAttributes() override;
	virtual void SetUserAlias(const FString& Key, const FString& Value) override;
	virtual void RemoveUserAlias(const FString& Key) override;
	virtual void ClearUserAlias() override;
	virtual void ClearUser() override;
	virtual void SetDeviceAlias(const FString& Key, const FString& Value) override;
	virtual void RemoveDeviceAlias(const FString& Key) override;
	virtual void ClearDeviceAlias() override;
	virtual void RegisterPushToken(const FString& Token) override;
	virtual void TrackEvent(
		const FString& Category,
		const UAirbridgeMap* SemanticAttributes,
		const UAirbridgeMap* CustomAttributes
	) override;
	virtual void Click(
		const FString& TrackingLink,
		const AirbridgeVoidParamFunction OnSuccess,
		const AirbridgeStringParamFunction OnFailure
	) override;
	virtual void Impression(
		const FString& TrackingLink,
		const AirbridgeVoidParamFunction OnSuccess,
		const AirbridgeStringParamFunction OnFailure
	) override;
	virtual void FetchDeviceUUID(
		const AirbridgeStringParamFunction OnSuccess,
		const AirbridgeStringParamFunction OnFailure
	) override;
	virtual void FetchAirbridgeGeneratedUUID(
		const AirbridgeStringParamFunction OnSuccess,
		const AirbridgeStringParamFunction OnFailure
	) override;
	virtual void SetOnAttributionReceived(const AirbridgeMapParamFunction OnAttributionReceived) override;
	virtual void CreateTrackingLink(
		const FString& Channel,
		const UAirbridgeMap* Option,
		const AirbridgeTrackingLinkParamFunction OnSuccess,
		const AirbridgeStringParamFunction OnFailure = nullptr
	) override;
	virtual FString CreateWebInterfaceScript(const FString& WebToken, const FString& PostMessageScript) override;
	virtual void HandleWebInterfaceCommand(const FString& Command) override;
	virtual void StartInAppPurchaseTracking() override;
	virtual void StopInAppPurchaseTracking() override;
	virtual bool IsInAppPurchaseTrackingEnabled() override;
	virtual void SetOnInAppPurchaseReceived(const AirbridgeInAppPurchaseParamFunction OnReceived) override;
};
